Attribute VB_Name = "mBehaviors"
Option Explicit

Public Type tBasicBehavior
    Cohesion      As Double
    Sepatation    As Double
    InvSeparation As Double
    Alignment     As Double
End Type

Public Type tBehavior
    Strength      As tBasicBehavior
    Distances     As tBasicBehavior
    R             As Double
    G             As Double
    B             As Double
End Type

Public BehaviorTable() As tBehavior


Public NofBehaviors As Long

Public MaxInteractDist As Double
Public MaxInteractDist2 As Double


Public Sub InitBehaviors()
    Dim I         As Long
    Dim J         As Long

    NofBehaviors = 3

    ' They are how do MyType behave respect to Other Type, so:
    ReDim BehaviorTable(NofBehaviors, NofBehaviors)


    For I = 1 To NofBehaviors
        For J = 1 To NofBehaviors
            With BehaviorTable(I, J)

                .Distances.Alignment = 110
                .Distances.Cohesion = 80
                .Distances.Sepatation = 50

                .Strength.Alignment = 0.1
                .Strength.Cohesion = 0.1
                .Strength.Sepatation = 1

                'To make Behavior I random respect to J
'                                .Strength.Alignment = .Strength.Alignment * (0 + Rnd)
'                                .Strength.Cohesion = .Strength.Cohesion * (-1 + Rnd * 2)
'                                .Strength.Sepatation = .Strength.Sepatation * (0.5 + Rnd)


                .Distances.Alignment = .Distances.Alignment * .Distances.Alignment
                .Distances.Cohesion = .Distances.Cohesion * .Distances.Cohesion
                .Distances.Sepatation = .Distances.Sepatation * .Distances.Sepatation
                .Distances.InvSeparation = 1 / (.Distances.Sepatation)

                If .Distances.Alignment > MaxInteractDist2 Then MaxInteractDist2 = .Distances.Alignment
                If .Distances.Cohesion > MaxInteractDist2 Then MaxInteractDist2 = .Distances.Cohesion
                If .Distances.Sepatation > MaxInteractDist2 Then MaxInteractDist2 = .Distances.Sepatation

                Do
                    .R = Rnd: .G = Rnd: .B = Rnd
                Loop While .R * 3 + .G * 5 + .B * 1 < 3.5

            End With
        Next
    Next

    For I = 1 To NofBehaviors
        For J = 1 To NofBehaviors
            If I <> J Then
                BehaviorTable(I, J).Strength.Alignment = 0
                BehaviorTable(I, J).Strength.Sepatation = 0
                BehaviorTable(I, J).Strength.Cohesion = -50000 * BehaviorTable(I, J).Strength.Cohesion
            End If
        Next
    Next

    MaxInteractDist = Sqr(MaxInteractDist2)

End Sub
